/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.asgteach.people.service;

import com.asgteach.people.model.Employee;
import com.gluonhq.cloudlink.client.data.RemoteFunctionBuilder;
import com.gluonhq.cloudlink.client.data.RemoteFunctionObject;
import com.gluonhq.connect.GluonObservableObject;
import com.gluonhq.connect.converter.JsonConverter;
import javax.json.JsonObject;

/**
 *
 * @author gail
 */
public class RemoteService {

    public <T> GluonObservableObject<T> getEmployees(Class<T> clazz) {
        RemoteFunctionObject function = RemoteFunctionBuilder
                .create("getEmployees")
                .object();
        return function.call(clazz);
    }

    public <T> GluonObservableObject<T> getEmployee(Class<T> clazz, String value) {
        RemoteFunctionObject function = RemoteFunctionBuilder
                .create("getEmployee")
                .param("empno", value)
                .object();
        return function.call(clazz);
    }

    public <T> GluonObservableObject<T> createEmployee(Class<T> clazz, Employee value) {
        JsonConverter j = new JsonConverter<>(Employee.class);
        JsonObject myj = j.writeToJson(value);
        System.out.println("json data = " + myj);
        RemoteFunctionObject function = RemoteFunctionBuilder
                .create("createEmployee")
                .rawBody(myj.toString().getBytes())
                .object();
        return function.call(clazz);
    }

    public <T> GluonObservableObject<T> deleteEmployee(Class<T> clazz, String value) {
        System.out.println("deleteEmployee for " + value);
        RemoteFunctionObject function = RemoteFunctionBuilder
                .create("deleteEmployee")
                .param("empno", value)
                .object();
        return function.call(clazz);
    }

    public <T> GluonObservableObject<T> updateEmployee(Class<T> clazz, Employee value) {
        JsonConverter j = new JsonConverter<>(Employee.class);
        JsonObject myj = j.writeToJson(value);
        System.out.println("json data = " + myj);
        RemoteFunctionObject function = RemoteFunctionBuilder
                .create("updateEmployee")
                .rawBody(myj.toString().getBytes())
                .object();
        return function.call(clazz);
    }

}
